<?php

// for woocommerce status update from xpressdelivery
  add_action( 'rest_api_init', 'wpshout_register_routes_new' ); 
function wpshout_register_routes_new() {
    register_rest_route( 'xpressdelivery/v1','/order/(?P<order_id>\d+)/(?P<status>\w+)',
        array(
    'methods' => WP_REST_Server::READABLE,
    'callback' => 'order_status_update',
  )
    );
}

function order_status_update( $data ) {
   
  $info = $data->get_url_params();
  $order = new WC_Order($info['order_id']);
    $synchronize_status = get_option('synchonize_status');
  if($synchronize_status=='true'){
    if($info['status']=='inprogress'){
      $status = 'arrived';
    }else{
       $status = sanitize_text_field($info['status']);
    }
  }else{
  if($info['status']=='successful'){
    $status = 'completed';
  }else{
    $status = sanitize_text_field($info['status']);
  }
  }
$res = $order->update_status($status);
 
}

add_action( 'rest_api_init', 'wpshout_register_routes_for_token' ); 
function wpshout_register_routes_for_token() {
    register_rest_route( 'xpressdelivery/v2','/order/(?P<order_id>\d+)/(?P<token>\w+)',
        array(
    'methods' => WP_REST_Server::READABLE,
    'callback' => 'get_order_token',
  )
    );
}

function get_order_token( $data ) {
   // print_r($data);
  
  $info = $data->get_url_params();
  $order = new WC_Order($info['order_id']); 
update_post_meta($info['order_id'],'task_token',$info['token']);

}

function register_new_custom_order_statuses() {

        register_post_status( 'wc-started', array(
            'label'                     => _x( 'started', 'Order status', 'textdomain' ),
            'public'                    => true,
            'exclude_from_search'       => false,
            'show_in_admin_all_list'    => true,
            'show_in_admin_status_list' => true,
            'label_count'               => _n_noop( 'started <span class="count">(%s)</span>', 'started <span class="count">(%s)</span>' )
        ) );
        
         register_post_status( 'wc-acknowledged', array(
            'label'                     => _x( 'acknowledged', 'Order status', 'textdomain' ),
            'public'                    => true,
            'exclude_from_search'       => false,
            'show_in_admin_all_list'    => true,
            'show_in_admin_status_list' => true,
            'label_count'               => _n_noop( 'acknowledged <span class="count">(%s)</span>', 'acknowledged <span class="count">(%s)</span>' )
        ) );
        
     register_post_status( 'wc-inprogress', array(
            'label'                     => _x( 'inprogress', 'Order status', 'textdomain' ),
            'public'                    => true,
            'exclude_from_search'       => false,
            'show_in_admin_all_list'    => true,
            'show_in_admin_status_list' => true,
            'label_count'               => _n_noop( 'inprogress <span class="count">(%s)</span>', 'inprogress <span class="count">(%s)</span>' )
        ) );
    
        register_post_status( 'wc-assigned', array(
            'label'                     => _x( 'assigned', 'Order status', 'textdomain' ),
            'public'                    => true,
            'exclude_from_search'       => false,
            'show_in_admin_all_list'    => true,
            'show_in_admin_status_list' => true,
            'label_count'               => _n_noop( 'assigned <span class="count">(%s)</span>', 'assigned <span class="count">(%s)</span>' )
        ) );

        register_post_status( 'wc-unassigned', array(
            'label'                     => _x( 'unassigned', 'Order status', 'textdomain' ),
            'public'                    => true,
            'exclude_from_search'       => false,
            'show_in_admin_all_list'    => true,
            'show_in_admin_status_list' => true,
            'label_count'               => _n_noop( 'unassigned <span class="count">(%s)</span>', 'unassigned <span class="count">(%s)</span>' )
        ) );

        register_post_status( 'wc-declined', array(
            'label'                     => _x( 'declined', 'Order status', 'textdomain' ),
            'public'                    => true,
            'exclude_from_search'       => false,
            'show_in_admin_all_list'    => true,
            'show_in_admin_status_list' => true,
            'label_count'               => _n_noop( 'declined <span class="count">(%s)</span>', 'declined <span class="count">(%s)</span>' )
        ) );
        
        register_post_status( 'wc-arrived', array(
            'label'                     => _x( 'arrived', 'Order status', 'textdomain' ),
            'public'                    => true,
            'exclude_from_search'       => false,
            'show_in_admin_all_list'    => true,
            'show_in_admin_status_list' => true,
            'label_count'               => _n_noop( 'arrived <span class="count">(%s)</span>', 'arrived <span class="count">(%s)</span>' )
        ) );
        
        register_post_status( 'wc-successful', array(
            'label'                     => _x( 'successful', 'Order status', 'textdomain' ),
            'public'                    => true,
            'exclude_from_search'       => false,
            'show_in_admin_all_list'    => true,
            'show_in_admin_status_list' => true,
            'label_count'               => _n_noop( 'successful <span class="count">(%s)</span>', 'successful <span class="count">(%s)</span>' )
        ) );
    
}
add_action( 'init', 'register_new_custom_order_statuses' );

// Register new statuses in wc_order_statuses (function).
add_filter( 'wc_order_statuses', 'register_new_custom_wc_order_statuses' );
function register_new_custom_wc_order_statuses( $order_statuses ) {
    
    $order_statuses['wc-started'] = _x( 'started', 'Order status', 'textdomain' );
     $order_statuses['wc-declined'] = _x( 'declined', 'Order status', 'textdomain' );
    $order_statuses['wc-assigned'] = _x( 'assigned', 'Order status', 'textdomain' );
     $order_statuses['wc-unassigned'] = _x( 'unassigned', 'Order status', 'textdomain' );
      $order_statuses['wc-acknowledged'] = _x( 'acknowledged', 'Order status', 'textdomain' );
       $order_statuses['wc-inprogress'] = _x( 'inprogress', 'Order status', 'textdomain' );
        $order_statuses['wc-arrived'] = _x( 'arrived', 'Order status', 'textdomain' );
         $order_statuses['wc-successful'] = _x( 'successful', 'Order status', 'textdomain' );
    return $order_statuses;
}


function wc_reports_get_order_custom_report_data_args( $args ) {
    $args['order_status'] = array( 'completed', 'processing', 'on-hold', 'accepted', 'started' );
    return $args;
};
add_filter( 'woocommerce_reports_get_order_report_data_args', 'wc_reports_get_order_custom_report_data_args');

// end for woocommerce status update from xpressdelivery

function sv_wc_add_my_account_orders_column( $columns ) {

    $new_columns = array();

    foreach ( $columns as $key => $name ) {

        $new_columns[ $key ] = $name;

        // add ship-to after order status column
        if ( 'order-status' === $key ) {
            $new_columns['order-ship-to'] = __( 'Track Order', 'textdomain' );
        }
    }

    return $new_columns;
}
add_filter( 'woocommerce_my_account_my_orders_columns', 'sv_wc_add_my_account_orders_column' );


function sv_wc_my_orders_ship_to_column( $order) {

$status = $order->get_status();
$id = $order->get_order_number();
$token = get_post_meta( $id, 'task_token', true );
$tack_link = isset($token)?'http://xpressdelivery.app/db/track/?id='.$token:'';
$array = array('assigned','unassigned','failed','processing',);
if(!in_array($status,$array)){
  $link ='';
  $link .= "<a href='$tack_link' target='_blank'>";
  $link .= $tack_link;
  $link .= '</a>';
}
//code by kalim to sanitize start
$link = filter_var($link, FILTER_SANITIZE_URL);
//code by kalim to sanitize end
  echo ! empty( $link ) ? $link : '&ndash;';
}
add_action( 'woocommerce_my_account_my_orders_column_order-ship-to', 'sv_wc_my_orders_ship_to_column' );
?>